<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;
			
	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/classes/PolarisLinkAPI.php");
	require_once(_PS_ROOT_DIR_ . "/modules/polarislink/models/PolarisLinkPhotos.php");	
	
	/*
	 * soumission des photos Polaris
	 *
	 */
	class PolarisLinkAPI_storePhotoModuleFrontController extends PolarisLinkAPI
	{
		protected function runAPI()
		{
			// Surtout plus de cache !!!
			Db::getInstance()->disableCache();

			$id_polaris = intval(isset($_REQUEST['id']) ? $_REQUEST['id'] : null);
			$etag = isset($_REQUEST['etag']) ? $_REQUEST['etag'] : null;
			
			if (empty($id_polaris))
				throw new Exception("vous devez spécifier un id valide pour la photo soumise");
			
			if (empty($etag))
				throw new Exception("vous devez spécifier votre ETag pour la photo soumise");
			
			// Stockage de la photo dans le répertoire de travail ...
			$photo_path = PolarisLinkAPI::GetPolarisPhotoPathFor($this->Link->LinkID, $id_polaris);
			
			// Stockage de la photo	
			if (!$outStream = fopen($photo_path, "w"))
				throw new Exception("impossible d'ouvrir un fichier de stockage pour la photo");
			
			$inStream = fopen("php://input", "rb");
			stream_copy_to_stream($inStream, $outStream);
			fclose($outStream);
			fclose($inStream);
			
			// Validation intégrité donnée
			$currentEtag = md5_file($photo_path)."-".filesize($photo_path);
			if (!empty($etag) && $currentEtag != $etag)				
				throw new Exception(sprintf(
					"le md5 ou la taille n'est pas conforme : la photo a visiblement été corrompue avant ou pendant le transfert (attendu : %s, transféré : %s)",
					$etag, $currentEtag));

			// Création ou chargement de la référence photo ...
			$photo = PolarisLinkPhotos::loadByIdPolaris($this->Link->LinkID, $id_polaris);
			if (empty($photo))
			{
				$photo = new PolarisLinkPhotos();
				$photo->id_link = $this->Link->LinkID;
				$photo->id_polaris = $id_polaris;
				$photo->etag = "";
			}
			$photo->etag = $etag;
			$photo->save();
			
			$this->answerJSON(array(
								"id" => intval($photo->id_polaris), 
								"len" => filesize($photo_path),
								"etag" => $photo->etag));
			
			return true;
		}
	}
 